﻿#targetengine "session"
#include "MT-ScriptLang.jsx"

	var myParentFolder = myGetScriptPath()
	var TestMyLoad = false;
	var myOutCount = 0;
	var myCheckFMT = false

	try { TestMyLoad = !ToLoadCommon }
	catch (err) {TestMyLoad = false}
	
	if (!TestMyLoad) {
	
			myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsxbin")
			
			if (!myCommonFile.exists) {
				myCommonFile = new File(myParentFolder+"/MT-Common1-09.jsx")
				}
	
			try {
				app.doScript(myCommonFile, ScriptLanguage.JAVASCRIPT)
				TestMyLoad = true
				}
			catch (err) {
				TestMyLoad = false
				alert(err+localize(Message1), "MT-Script 1-09", true)
				}
		
	}

	if (TestMyLoad) {
			if (GlobalScriptPath) {mainPaste()}
			else {alert(GlStr, "MT-Script 1-09", true)}
		}

//********************************************//

function mainPaste()
	{
	var myTextFind, myFileName, myBaseLine, myDirPath
	
	var myDocument = app.activeDocument;
	
	app.scriptPreferences.enableRedraw = false
	
	var myResult = false;
	
	#include "MT-Load.jsx"

	myScript = new File(myParentFolder+"/MT-Dialog1-09.jsx")
			
	if (!myScript.exists) {
		myScript = new File(myParentFolder+"/MT-Dialog1-09.jsxbin")
		}
			
	if (myScript.exists) {
			app.doScript(myScript, ScriptLanguage.javascript)
			myResult = true
			}
		else {
			alert(localize(Message58), "MT-Script 1-09", false)
			}

if (myResult == true) {
	
	var myDir = Folder.selectDialog(localize(Message57), myPath);
	
	if (myDir != null) {
		
	myDirPath = myDir.toString() + "/";

	try {
			if (myIniFile.open('w')) {
				
						myIniFile.writeln(myDirPath);
						myIniFile.writeln(dopBaseShift);
						myIniFile.writeln(AlfaFormula);
						myIniFile.writeln(BetaFormula);
						myIniFile.writeln(myLeadingFlag.toString());
						myIniFile.writeln(ScaleFormula);
						myIniFile.writeln(myScaleFlag.toString());
						myIniFile.writeln(myCP.toString());
						myIniFile.writeln(myDoubleFlag.toString());
						myIniFile.writeln(myContinueFlag.toString());
						myIniFile.writeln(myDopShiftingFlag.toString());
						myIniFile.writeln(DopShifting);
						myIniFile.writeln(myTransactionFlag.toString());
						myIniFile.writeln(myCompType);
						myIniFile.writeln(myLanguage);
						myIniFile.close(); }

			}
		catch (err)
		{
			alert(err+localize(Message20))
			}
		
    with (app.activeDocument.viewPreferences)
	{
      myOldXUnits = horizontalMeasurementUnits;
      myOldYUnits = verticalMeasurementUnits;

      horizontalMeasurementUnits = MeasurementUnits.POINTS;
      verticalMeasurementUnits = MeasurementUnits.POINTS;
    }
    
  try {
	var mySelections = myDocument.selection
	var mySelection = mySelections[0]
	switch (mySelection.constructor.name) {
		case "Text":
		case "TextColumn":
		case "TextStyleRange":
		case "TextFrame":
		case "Paragraph":
		case "Cell":
		case "Table":

			alert(localize(Message14) + mySelection.constructor.name + localize(Message22), "MT-Script 1-09", false);
			IsPlaced = 0;
			for (var j = 0; j < mySelections.length; j++) {
				 IsPlaced = IsPlaced + Place_Equation (mySelections[j], myDirPath)}
			break;
			
		case "InsertionPoint":
				alert(localize(Message21), "MT-Script 1-09", false) 
				IsPlaced = Place_Equation (myDocument, myDirPath)
			break;
		}	
	}
    catch(err) {
		alert(localize(Message21), "MT-Script 1-09", false) 
		IsPlaced = Place_Equation (myDocument, myDirPath)}

    with (app.activeDocument.viewPreferences)
	{
      horizontalMeasurementUnits = myOldXUnits
      verticalMeasurementUnits = myOldYUnits
    }
	app.scriptPreferences.enableRedraw = true
    alert(localize(Message23) + (IsPlaced+myOutCount) + localize(Message26) + IsPlaced + localize(Message24) + myOutCount + localize(Message25), "MT-Script 1-09", false)
	}

}
}


// ************************************************************************************************** //

function myGetScriptPath() {
    try{
        return File(app.activeScript).parent;
    }
    catch(myError){
        return File(myError.fileName).parent;
    }
}


// ************************************************************************************************** //

function Place_Equation (myObject, myDirPath) {
	
	app.findGrepPreferences = NothingEnum.nothing;
	    
    myMask = "<<Eqn\\d+.[\\l\\u]+>>"
    
    app.findGrepPreferences.findWhat = myMask
	
    var myGrep = myObject.findGrep()
	
	var myCount = myGrep.length
   
	if (myCP) {var myIncrement = (myCount-1)/200;
					myCreateProgressPanel(200, 600, "MT-Script1-09 placing new equations...");
					myProgressPanel.show();}
	
	var OutCount = 0;
   
    for (var i = 0; i < myCount; i++) {
      
			myTextFind = myGrep[i]

			if (myCP) {myProgressPanel.myProgressBar.value = i/myIncrement;}
	  
			myFileName = myTextFind.contents
      
			myFileName = myFileName.substr(2, myFileName.length - 4)

			myFile = myDirPath + myFileName
	
			var FileForPlace = new File(myFile)
			
			if (myCheckFMT == true) {
					OnlyFileName  = FileForPlace.name
					SplitFileName = OnlyFileName.split(".")
					NewOnlyFileName = SplitFileName[0] + ".fmt"
					myFile = myDirPath + NewOnlyFileName
					FileForPlace.rename(NewOnlyFileName)
				}

			if (FileForPlace.exists == true) {
					
					myTextFind.place (FileForPlace)
	
					var myRectangle = myTextFind.parent.rectangles.item(-1)
		
					myBaseLine = GetBaseLineShift(myFile, dopBaseShift, myRectangle.graphics.item(0).imageTypeName)
	
					with (myRectangle) {
						anchoredObjectSettings.anchorYoffset = -myBaseLine

						with (textWrapPreferences) {
							inverse = false
							if (app.scriptPreferences.version == 5.0) {
									textWrapType = TextWrapTypes.JUMP_OBJECT_TEXT_WRAP}
							else {textWrapMode = TextWrapModes.JUMP_OBJECT_TEXT_WRAP}
							textWrapOffset = [0,0,BetaFormula,0]
							} // end with pref
						
						if (myLeadingFlag == true) {                    
							try {
								UpShift = geometricBounds[2] - geometricBounds[0] - myBaseLine + AlfaFormula
									if (UpShift > 1) {
										parent.leading = UpShift
										} else {parent.leading = 1}
									if (AlfaFormula == -100) {
										parent.leading = 1635019116
										}
								}
							catch (err) {}
						} // end if (myLeading
		
						} // end with myRect
				
				} // end if exists
				else {OutCount++}

		} // end for i = 0
	
	myOutCount = myOutCount + OutCount;
	
	if (myCP) {myProgressPanel.myProgressBar.value = 0; myProgressPanel.hide();}
	
	return i - OutCount;
	
	}

